Simple-Configuration
================================================

This is a small scheme library to hande configurations in a simple manner.
It uses lists as the basic datastructure to hold configurations.

Examples:

    (define my-config
     '((production
        (database
          (username "prod")
          (password "prodpwd")
          (host "test.example.com")))
       (development
        (database
          (username "dev")
          (password "devpwd")
          (host "dev.example.com")))
      (logging
       (destination "/var/log/application.log")
       (levels (error warning)))))

    ;; now you can access the data like so

    (config-ref my-config '(production database username)) ;; => "prod"
    (config-ref my-config '(production database))          ;; => (username "prod")
    (config-ref my-config '(production database))   ;; => ((username "prod") (password "prodpwd") (host "test.example.com"))

    (config-let my-config ((db-user (production database username))
                           (db-pw   (production database password))
                           (db-host (production database host)))
      (connect-to-database db-host db-user db-pw))

    ;; postprocess data
    (config-ref my-config '(logging levels) post-process: (lambda (ls) (cons 'critical ls))) ;; => (critical error warning)



